import qualified Data.Vector.Unboxed as V
import Data.Bits
import Data.Int
import System.CPUTime
import Control.Monad
import Criterion.Main
import Criterion.Config

a :: V.Vector Int16
a = V.generate 256 (\i -> fromIntegral (i .&. 1))

b :: V.Vector Int16
b = V.generate 256 (\i -> fromIntegral (i .&. 3))

squareError :: Int16 -> Int16 -> Int
squareError x y = d * d 
  where 
    d :: Int
    d = fromIntegral (x - y)

calc :: V.Vector Int16 -> Int
calc b = V.foldl1' (+) (V.zipWith squareError a b)

myConfig = defaultConfig { cfgSamples  = ljust 10000 }


main = 
  defaultMainWith myConfig (return ()) [bench "calc" (whnf calc b)]
  